<template>
  <section clobeditor :fullscreen="fullscreen">
    <md-app-toolbar class="md-primary" md-elevation="0">
      <img v-if="!this.editorrow" src="/img/hourglass_color.gif" alt="tick tock tick tock">

      <md-button class="md-icon-button md-primary" @click="fullscreen = !fullscreen" :active="fullscreen">
        <md-icon :md-src="fullscreen ? '/img/md/fullscreen_exit.svg': '/img/md/fullscreen.svg'"/>
      </md-button>

      <md-button class="md-icon-button md-primary" @click="wrap = !wrap" :active='wrap'>
        <md-icon md-src="/img/md/wrap_text.svg"/>
      </md-button>

      <md-button class="md-icon-button md-primary" @click="showInvisibles = !showInvisibles" :active='showInvisibles'>
        <md-icon md-src="/img/pilcrow.svg"/>
      </md-button>

      <md-button class="md-icon-button md-primary" @click="download" :disabled="isReadMode"><md-icon md-src="/img/md/save_alt.svg"/></md-button>
      <md-button class="md-icon-button md-primary" @click="upload" :disabled="isReadMode"><md-icon md-src="/img/md/publish.svg"/></md-button>
    </md-app-toolbar>
    <pre ref='ace'></pre>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
import { MdSwitch, MdCard } from 'vue-material/dist/components';
import { KeyPathKey } from '../../store/editor';
import { store } from '../../store';
import { download, upload } from '../../lib/clob';

import * as ace from 'brace';
import 'brace/mode/xml';
import 'brace/mode/json';
import 'brace/theme/chrome';
import { CompiledRow } from './rowEditor.vue';

@Component({
  components: {
  },
})
export default class extends Vue {

  get fullscreen() {
    return this.keyEntry && !!this.keyEntry.options.fullscreen;
  }

  set fullscreen(val: boolean) {
    const keypath = store.state.editor.keyPath;
    const options = Object.assign({}, keypath[keypath.length - 1].options);
    if (val) {
      options.fullscreen = 'true';
    } else {
      delete options.fullscreen;
    }
    store.commit.editor('changeKeyPath', {entry: {options}});
  }

  @Prop()
  private editorrow!: CompiledRow;

  @Prop()
  private keyEntry!: KeyPathKey;

  private editor?: ace.Editor;

  private wrap = true;
  private showInvisibles = false;

  public mounted() {
    const e = this.editor = ace.edit(this.$refs.ace as HTMLElement);
    this.modeChanged(this.isReadMode);
    this.wrapChanged(this.wrap);
    e.$blockScrolling = Infinity;
    e.setTheme('ace/theme/chrome');
    this.editorRowChanged(this.editorrow);
    e.getSession().on('change', event => {
      this.editorrow.newValue = e.getValue();
    });
  }

  public upload() {
    upload().then(newContent => {
      if (newContent) {
        this.editorrow.newValue = newContent;
      }
    });
  }

  public download() {
    download(this.editorrow);
  }

  @Watch('editorrow', {deep: true})
  private editorRowChanged(val: CompiledRow) {
    if (this.editor && val) {
      const content = val.newValue;
      if (content !== this.editor.getValue()) {
        try {
          JSON.parse(content);
          this.editor.getSession().setMode('ace/mode/json');
        } catch (e) {
          this.editor.getSession().setMode('ace/mode/xml');
        }
        this.editor.setValue(content);
      }
    }
  }

  get isReadMode() {
    return store.get.auth('isReadMode');
  }

  @Watch('isReadMode')
  private modeChanged(isReadMode) {
    if (this.editor) {
      this.editor.setReadOnly(isReadMode);
    }
  }

  @Watch('wrap')
  private wrapChanged(wrap) {
    if (this.editor) {
      this.editor.session.setUseWrapMode(wrap);
    }
  }

  @Watch('showInvisibles')
  private showInvisiblesChanged(showInvisibles) {
    if (this.editor) {
      this.editor.renderer.setShowInvisibles(showInvisibles);
    }
  }
}
</script>

<style lang="scss" scoped>
[clobeditor] {
  min-width: 800px;
  height: 100%;
  display: flex;
  flex-direction: column;
  flex: 1;

  &[fullscreen] {
    flex: 1;
  }

  pre {
    margin: 0;
    flex: 1;
  }
}
</style>
<style lang="scss">
[clobeditor] {
  .md-button {
    &[disabled] {
      .md-icon.md-icon.md-icon.md-icon {
        svg {
          fill: rgba(255,255,255,.3);
        }
      }
    }
    &[active] {
      background: rgba(255,255,255,.3);
    }
  }
}
</style>
